﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Default.aspx.vb" Inherits="MindFusion.Scheduling.Samples.VB.ClientEvents._Default" %>

<%@ Register Assembly="MindFusion.Scheduling.WebForms" Namespace="MindFusion.Scheduling.WebForms"
    TagPrefix="MindFusion" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
  <title>MindFusion WebPlanner Sample - Client Events</title>
	<link href="common/jquery-ui.min.css" rel="stylesheet" />
	<link href="common/samples.css" rel="stylesheet" />
	<script type="text/javascript" src="common/jquery.min.js"></script>
	<script type="text/javascript" src="common/jquery-ui.min.js"></script>
	<script type="text/javascript" src="common/samples.js"></script>
	<style type="text/css">
		.Workday .frame, .Workday.selected .frame
		{
			background-image: none !important;
			background: navy !important;
		}
		.Weekend .frame, .Weekend.selected .frame
		{
			background-image: none !important;
			background: firebrick !important;
		}
		.Workday .frame .subject, .Weekend .frame .subject
		{
			color: white !important;
		}
	</style>
</head>
<body>
	<form id="form2" runat="server">
	<asp:ScriptManager ID="ScriptManager2" runat="server">
	</asp:ScriptManager>
	<input type="hidden" id="collapsed" runat="server" />
	<div id="header" style="height: 49px;">
		<div style="float: right; margin-right: 5px; margin-top: 17px;">
			<button id="expandButton" onclick="onExpandCollapse()">
				&gt;</button>
		</div>
	</div>
	<div id="info" style="top: 60px; bottom: 24px;">
		<div id="infoTab" style="padding: 10px;">
			<h1>
				About this sample</h1>
			<p>
				This sample demonstrates the use of some of the WebPlanner's client events. When
				a date cell is clicked, a new appointment will be created automatically. The appointment
				will have workday or weekend style depending on the day of week in which it is created.
				This behavior is achieved by handling the selectionEnd and itemCreating events.
				Workday appointments cannot be dragged to weekend cells and vice-versa. This is
				done by handling the itemDragEnd event. Additionaly, the built-in popup forms are
				altered on the formShow event. Certain controls are hidden in order to prevent users
				from editing the appointments' start and end time and creating recurrences.
			</p>
		</div>
	</div>
	<div id="content" style="top: 60px; bottom: 24px;">
		<div style="position: absolute; left: 0px; top: 0px; bottom: 0px; right: 0px">
			<MindFusion:Calendar ID="Calendar1" runat="server" Height="100%" Theme="Vista" Width="100%"
				ItemDragEndScript="itemDragEnd" ItemCreatingScript="itemCreating" ItemResizeEndScript="itemResizeEnd"
				FormShowScript="formShow" SelectionEndScript="selectionEnd">
				<Selection AllowMultiple="Disabled" />
			</MindFusion:Calendar>
		</div>
	</div>
	<div id="footer" style="height: 24px;">
		<span id="copyright"></span>
	</div>
	<script type="text/javascript">
	    function isInWeekend(start, end)
	    {
	        while (start < end)
	        {
	            if (start.__getDay() == 6 || start.__getDay() == 0)
	                return true;
	            start = MindFusion.Common.DateTime.addDays(start, 1);
	        }
	        return false;
	    }
	    function isInWorkday(start, end)
	    {
	        while (start < end)
	        {
	            if (start.__getDay() != 6 || start.__getDay() != 0)
	                return true;
	            start = MindFusion.Common.DateTime.addDays(start, 1);
	        }
	        return false;
	    }

	    function itemResizeEnd(sender, args)
	    {
	        var inWeekend = isInWeekend(args.get_changes().startTime.clone(), args.get_changes().endTime.clone());
	        var inWorkday = isInWorkday(args.get_changes().startTime.clone(), args.get_changes().endTime.clone());
	        var item = args.get_item();
	        if ((item.cssClass == 'Workday' && inWeekend) ||
				(item.cssClass == 'Weekend' && inWorkday))
	        {
	            args.set_cancel(true);
	        }
	    }

	    function itemDragEnd(sender, args)
	    {
	        var cell = sender.getTimeCell(args.get_changes().startTime);
	        var item = args.get_item();
	        if (item.cssClass == 'Workday')
	        {
	            if (cell.startTime.__getDay() == 6 || cell.startTime.__getDay() == 0)
	            {
	                args.set_cancel(true);
	            }
	        }
	        else if (item.cssClass == 'Weekend')
	        {
	            if (cell.startTime.__getDay() != 6 && cell.startTime.__getDay() != 0)
	            {
	                args.set_cancel(true);
	            }
	        }
	    }

	    function itemCreating(sender, args)
	    {
	        var item = args.get_item();
	        if (item.startTime.__getDay() != 6 && item.startTime.__getDay() != 0)
	        {
	            if (item.subject == '')
	            {
	                item.subject = 'Workday event';
	            }
	            item.details = 'Never do this on weekends!';
	            item.cssClass = 'Workday';
	        }
	        else if (item.startTime.__getDay() == 6 || item.startTime.__getDay() == 0)
	        {
	            if (item.subject == '')
	            {
	                item.subject = 'Weekend event';
	            }
	            item.details = 'Never do this on workdays!';
	            item.cssClass = 'Weekend';
	        }
	    }

	    function formShow(sender, args)
	    {
	        var form = args.get_form();
	        if (form.id == 'NewForm')
	        {
	            args.set_cancel(true);
	        }
	        if (form.id == 'EditForm')
	        {
	            form.getControls()['btnRecurrence'].element.style.display = 'none';
	            form.getControls()['TimeDiv'].style.display = 'none';
	        }
	    }

	    function selectionEnd(sender, args)
	    {
	        var startTime = args.get_startTime();
	        var endTime = args.get_endTime();

	        var item = {
	            startTime: startTime,
	            endTime: endTime,
	            allowMove: true,
	            allowChangeStart: true,
	            allowChangeEnd: true,
	            locked: false
	        };


	        if (startTime.__getDay() != 6 && startTime.__getDay() != 0)
	        {
	            item.subject = 'Workday event';
	            item.details = 'Never do this on weekends!';
	            item.allDayEvent = false;
	            item.cssClass = 'Workday';

	        }
	        else
	        {
	            item.subject = 'Weekend event';
	            item.details = 'Never do this on workdays!';
	            item.allDayEvent = false;
	            item.cssClass = 'Weekend';
	        }

	        sender.createItem(item);
	        args.set_cancel(true);
	    }

	</script>
	</form>
</body>
</html>
